package glg203.serialization;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

public class Main {
    
    private String fileName = "personGroup.ser";

    public void run() throws FileNotFoundException, IOException, ClassNotFoundException {
        System.out.println("** create and save **");
        createAndSave();
        System.out.println("** read again **");
        loadAndDisplay();    
    }


    private void createAndSave() throws FileNotFoundException, IOException {
        LogObserver log1 = new LogObserver("log 1");
        PersonGroup g = new PersonGroup();
        g.addObserver(log1);
        g.addPerson("turing", "cambridge");
        Person p = g.addPerson("wirth", "lausanne");
        p.setAddress("genève");
        
        // Sauvegarde
        File f = new File(fileName);
        if (! f.exists()) {
            try (
                FileOutputStream fileOut = new FileOutputStream(f);
                ObjectOutputStream out = new ObjectOutputStream(fileOut);
            ) {
                out.writeObject(g);
            }
        }
    }

    private void loadAndDisplay() throws FileNotFoundException, IOException, ClassNotFoundException {
        try (
            FileInputStream fileIn = new FileInputStream(fileName);
            ObjectInputStream in = new ObjectInputStream(fileIn);
        ) {
            PersonGroup group = (PersonGroup) in.readObject();  
            System.out.println("Group" + group);
            group.addPerson("p1", "a1"); // should not appear in log, as no logger is set.
            group.addObserver(new LogObserver("log 2"));
            group.addPerson("p2", "a2"); // should  appear in log.
            
        }
    }


    public static void main(String[] args) throws ClassNotFoundException, IOException {
        new Main().run();    
    }
}
