package glg203.serialization;

import java.io.Serializable;

import glg203.serialization.observer.events.EventType;
import glg203.serialization.observer.events.PersonEvent;

public class Person implements Serializable {
    private PersonGroup owner;
    private String name;
    private String address;

    public Person(PersonGroup owner, String name, String address) {
        this.owner = owner;
        this.name = name;
        this.address = address;
    }

    public void setAddress(String address) {
        this.address = address;
        notifyModification();
    }

    public void setName(String name) {
        this.name = name;
        notifyModification();
    }

    void clearOwner() {
        owner = null;
    }

    private void notifyModification() {
        if (owner != null) {
            owner.notifyModification(new PersonEvent(EventType.MODIFIED, this));
        }
    }

    @Override
    public String toString() {
        return "name "+ name + " address "+ address;
    }
}
