package demojdbc;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

/** Exemple de transactions avec commit et rollback */
public class Exemple8Transaction extends AbstractExample {
  
    public static void main(String[] args) throws SQLException {
        Exemple8Transaction m = new Exemple8Transaction();
        m.run();
    }

    @Override
    protected void fillDatabase(Connection db) throws SQLException {        
        // ne fait rien (le remplissage de la base est réalisé par doInDatabase)
    }

    @Override
    protected void doInDatabase(Connection connection) throws SQLException {
        createEntries(connection, 100);
        createEntries(connection,200);
        createEntries(connection,300);
    }



    /**
     * Crée des entrées, avec comme point de départ pour les id la valeur n.
     * déclenche un rollback is n est égal à 200.
     * @param db
     * @param n
     * @throws SQLException
     */
    private void createEntries(Connection db, int n) throws SQLException {
        String names[] = {
                "joe",
                "jack",
                "william",
                "averell"
        };
        String sql = "insert into person (id, name) values (?,?)";
        try (
                PreparedStatement pst = db.prepareStatement(sql);) {
            db.setAutoCommit(false); // mode transactionnel

            for (int i = 0; i < names.length; i++) {
                pst.setInt(1, n + i + 1);
                pst.setString(2, names[i]);
                pst.executeUpdate();
            }
            if (n == 200) {
                db.rollback();
            } else {
                db.commit();
            }
        }
    }
}
