package demojdbc;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.SQLException;

public class Exemple9Metadata extends AbstractExample {

    public static void main(String[] args) throws SQLException {
        new Exemple9Metadata().run();
    }

    /**
     * Dans cette méthode, nous explorons la base pour connaître ses tables et leurs champs.
     */
    @Override
    protected void doInDatabase(Connection connection) throws SQLException {
        DatabaseMetaData metaData = connection.getMetaData();
        // metaData.supp
        affiche("Base de données " + metaData.getDatabaseProductName());
        affiche("Récupération de clef générées : " + metaData.supportsGetGeneratedKeys());

        // On va regarder les données de toutes les tables...
        try (ResultSet mres = metaData.getTables("", "", 
                                                 "%", null)) {
            // On explore le ResultSet pour savoir combien il 
            // a de champs...
            int taille = mres.getMetaData().getColumnCount();
            // On les affiche
            while (mres.next()) {
                for (int i = 1; i <= taille; i++) {
                    System.out.print(mres.getMetaData().getColumnName(i) + ": ");
                    System.out.println(mres.getObject(i));
                }
            }            
        }
        System.out.println("** Les colonnes des tables **");
        afficheColonnes(connection);
    }

    private void afficheColonnes(Connection connection) throws SQLException {
        DatabaseMetaData metaData = connection.getMetaData();
        try (ResultSet mres = metaData.getColumns("", "", "%", "%")) {            
            int taille = mres.getMetaData().getColumnCount();
            // On les affiche
            while (mres.next()) {
                for (int i = 1; i <= taille; i++) {
                    System.out.print(mres.getMetaData().getColumnName(i) + ": ");
                    System.out.print(mres.getObject(i)+ ", ");
                }
                System.out.println();
            }            
        }
    }

    @Override
    protected void queryDatabase(Connection db) throws SQLException {
        // Rien, ça ne nous intéresse pas.
    }

    private void affiche(String s) {
        System.out.println(s);
    }
}
