package glg203.exemplemysql;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

public class ConnectionManager {
    /**
     * The driver name we use (for access by dbunit - not a very reasonable system.
     * Datasources would be better.
     * )
     */
    private String DRIVER_NAME = "com.mysql.cj.jdbc.Driver";
    private String url = "jdbc:mysql://localhost:3312/demo";
    private String user = "root";
    private String password = "root";

    public Connection getConnection() {
        try {
            return DriverManager.getConnection(url, user, password);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }

    public void doInConnection(ConnectedProcessing processing) {        
        try (Connection db = getConnection()) {
            processing.doWithConnection(db);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }

    public String getUrl() {
        return url;
    }

    public String getUser() {
        return user;
    }

    public String getPassword() {
        return password;
    }

    public String getDriverName() {
        return DRIVER_NAME;
    }
}
