package glg203.exemplemysql;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.List;
import java.util.Set;

public class Main {

    public static void main(String[] args) {
        new Main().run();
    }

    private BufferedReader in;

    public Main() {       
        this.in = new BufferedReader(new InputStreamReader(System.in));
    }

    public void run() {
        println("Do you want to : ");
        println("a) add a person");
        println("b) list the database content");
        String answer = askFor("a", "b");
        switch (answer) {
            case "a":
                addPerson();
                break;
            case "b":
                listPersons();
                break;
        }
    }

    private void listPersons() {
        new ConnectionManager().doInConnection(
                db -> {
                    List<Person> l = new PersonneDAO(db).findAll();
                    for (Person p : l) {
                        System.out.println(p);
                    }
                });
    }

    private void addPerson() {
        print("person id : ");
        int id = readInt();
        print("person name : ");
        String name = readline();
        new ConnectionManager().doInConnection(
                db -> {
                    new PersonneDAO(db).save(new Person(id, name));
                });
    }

    private String askFor(String... keys) {
        Set<String> possibleAnswers = Set.of(keys);
        String result = null;
        do {
            print("Please enter one of " + Arrays.toString(keys) + " : ");
            result = readline();
        } while (!possibleAnswers.contains(result));
        return result;
    }

    private void println(String text) {
        System.out.println(text);
    }

    private void print(String text) {
        System.out.print(text);
        System.out.flush();
    }

    private String readline() {
        try {
            return in.readLine();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    private int readInt() {
        String line = readline();
        return Integer.parseInt(line);
    }



}
